﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel

Class MainWindow
    Implements INotifyPropertyChanged


    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        Dim dllList As New ObservableCollection(Of String)

        For Each f In IO.Directory.GetFiles(My.Application.Info.DirectoryPath & "\dlls", "*.dll")
            Dim fi As IO.FileInfo = New IO.FileInfo(f)
            dllList.Add(Replace(fi.Name, ".dll", "")) '.dld wird weggeschnitten, schaut nicht gut aus
        Next
        AviableAssemblys = New ObservableCollection(Of String)(dllList)
        If AviableAssemblys.Count > 0 Then SelectedAssembly = AviableAssemblys.First
        Me.DataContext = Me
    End Sub



    Private _aviableAssemblys As ObservableCollection(Of String)
    Public Property AviableAssemblys() As ObservableCollection(Of String)
        Get
            Return _aviableAssemblys
        End Get
        Set(ByVal value As ObservableCollection(Of String))
            _aviableAssemblys = value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("AviableAssemblys"))
        End Set
    End Property

    Private _selectedAssembly As String
    Public Property SelectedAssembly() As String
        Get
            Return _selectedAssembly
        End Get
        Set(ByVal value As String)
            _selectedAssembly = value
        End Set
    End Property


    Private _currentVehiclesList As ObservableCollection(Of Model.Vehicle)


    Public Property CurrentVehicleList() As ObservableCollection(Of Model.Vehicle)
        Get
            Return _currentVehiclesList
        End Get
        Set(ByVal value As ObservableCollection(Of Model.Vehicle))
            _currentVehiclesList = value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("CurrentVehicleList"))
        End Set
    End Property

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private Sub btnLoad_Click(sender As Object, e As RoutedEventArgs)
        If SelectedAssembly Is Nothing Then Throw New Exception("Es muss eine DLL gewählt werden!!")
        Dim dll = Reflection.Assembly.LoadFile(My.Application.Info.DirectoryPath & "\dlls\" & SelectedAssembly & ".dll") 'Läd die dll
        Dim dlltype = dll.GetType(SelectedAssembly & ".Vehicles") 'typ setzen
        Dim c = Activator.CreateInstance(dlltype) 'Instanz erstellen
        Dim method = dlltype.GetMethod("GetVehicles") 'Metodeninfo holen
        CurrentVehicleList = New ObservableCollection(Of Model.Vehicle)(DirectCast(method.Invoke(c, Nothing), List(Of Model.Vehicle))) 'Methode aufrufen und gleich in die Liste laden

    End Sub
End Class
